{        -----===== Simple terminal program. FOSSIL required =====-----      }
{             -----===== The Broken XTs' House , Archi =====-----            }
{              -------====== Dynasty Resource Site ======-------             }
program terminal;
 uses dos,crt;
  const comport = 4;           {set this constant to com-port number}
                               {on what your modem is situated}
        fosport = comport-1;   {calculation of FOSSIL com-port code}
                               {FOSSIL uses 0 for com1, 1 for com2... etc}
  var   ch_       : char;
        axtmp     : word;
        old1C     : pointer;   {variable required to save old timer interrupt}
                               {vector}
        flag      : boolean;
{****************************************************************************}
procedure kbd_to_modem; interrupt;
  var chr  : char;
begin
  if keypressed
    then begin
      chr := ReadKey;
      if (chr = #0)
        then begin
          chr := ReadKey;
          flag := true;
        end;
      if (chr <> #68) then flag := false;
      asm
        mov dx,fosport   {dx <- com-port code}
        mov ah,1         {FOSSIL function - put with wait}
        mov al,chr       {al <- char to send}
        int 14h          {FOSSIL call}
      end;
    end;
end;
{**********************  FOSSIL initialization  *****************************}
procedure fossil_init;
begin
  asm
    mov dx,fosport
    mov ah,0
    mov al,00000011b
    int 14h
    mov dx,fosport      {dx <- com-port code}
    mov ah,4            {FOSSIL function 4 - init fossil}
    int 14h             {FOSSIL call}
  end;
end;
{********************** procedure fossil_init end ***************************}
begin
  fossil_init;
  flag := false;
  ClrScr;
  GetIntVec ($1C,old1C);    {save old timer interrupt vector}
  SetIntVec ($1C,@kbd_to_modem);
                            {set procedure as timer interrupt handler}
  WriteLn ('Terminal Copyright (c) 1996 Archi//Dynasty.');
  WriteLn ('F10 to QUIT.');
  repeat
    repeat    {--- repeat until there is something in fossil input buffer ---}
{--------------- Check, is there data for us in fossil buffer ---------------}
      asm
        mov dx,fosport    {dx <- com-port code}
        mov ah,3          {FOSSIL function - request status}
        int 14h           {FOSSIL call}
        and ax,0100h      {Select bit 0 of AH - RDA = input data}
                          {is available in buffer               }
        mov axtmp,ax
      end;
{----------------------------------------------------------------------------}
    until (axtmp > 0) or flag;
    if not flag then
      asm
        mov dx,fosport    {dx <- com-port code}
        mov ah,2          {FOSSIL function - get with wait}
        int 14h           {FOSSIL call}
        mov ch_,al        {Store received char in memory}
      end;
    Write (ch_);          {Write received char on screen}
  until flag;
  SetIntVec ($1C,old1C);    {restore old timer interrupt vector on exit}
end. 

